Draft BSpline

From FreeCAD Documentation
Revision as of 02:18, 8 November 2018 by Vocx (talk | contribs) ({{Button}} instead of {{KEY}} template; information removed because it's described in the options.)

Draft BSpline

Menu location
Draft → BSpline
Workbenches
Draft, Arch
Default shortcut
B S
Introduced in version
-
See also
Draft Wire, Draft Line

Description

The BSpline tool creates a B-Spline curve from several points in the current work plane. It uses the Draft Linestyle set on the Draft Tray. The BSpline tool behaves like the Draft Wire tool, but is curved.

How to use

  1. Press the Draft BSpline button, or press B then S keys
  2. Click a first point on the 3D view, or type a coordinate
  3. Click additional point on the 3D view, or type a coordinate

Options

  • Press F or the Finish button to finish the spline, leaving it open
  • Press C or the Close button or click on the first point to finish the spline, but making it closed by adding a last segment between the last point and the first one.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press ENTER between each X, Y and Z component.
  • Press R or click the checkbox to check/uncheck the Relative button. If relative mode is on, the coordinates of the next point are relative to the last one. If not, they are absolute, taken from the (0,0,0) origin point.
  • Press T or click the checkbox to check/uncheck the Continue button. If continue mode is on, the BSpline tool will restart after you finish or close it, allowing you to draw another one without pressing the BSpline button again.
  • Press CTRL while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Press SHIFT while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press W or press the Wipe button to remove the existing segments and start the spline from the last point.
  • Press CTRL+Z or press the Undo button to undo the last point.
  • Press I or the Filled button to have the spline filled with a face after it has been closed.
  • Press ESC or the Cancel button to abort the current BSpline command.
  • BSplines, when in "Flat Lines" display mode, can display a hatch pattern, by setting their "Pattern" property below.

Properties

  • DataClosed: Specifies if the spline is closed or not
  • DataMake Face: Fills the spline with a face
  • ViewEnd Arrow: Shows an arrow symbol at the last point of the spline, so it can be used as an annotation leader line
  • ViewPattern: Specifies a hatch pattern to fill the wire with
  • ViewPattern Size: Specifies the size of the hatch pattern

Scripting

The BSpline tool can by used in macros and from the python console by using the following function:

makeBSpline (pointslist,[closed],[placement])
  • Creates a B-Spline object from the given list of vectors.
  • If closed is True or first and last points are identical, the wire is closed.
  • If face is true (and the bspline is closed), the bspline will appear filled.
  • Instead of a list of points, you can also pass a Part Wire.
  • Returns the newly created object.

Example:

import FreeCAD,Draft
p1 = FreeCAD.Vector(0,0,0)
p2 = FreeCAD.Vector(1,1,0)
p3 = FreeCAD.Vector(2,0,0)
Draft.makeBSpline([p1,p2,p3],closed=True)